import * as React from "react";
import { Context } from "almin";
export declare type AlminReactContainerDiff<T, U> = T extends U ? never : T;
export declare type AlminReactContainerObjectDiff<T, U> = Pick<T, AlminReactContainerDiff<keyof T, keyof U>>;
export declare class AlminReactContainer {
    static create<T, P>(WrappedComponent: React.ComponentType<T>, context: Context<P>): {
        new (props: any): {
            state: P;
            unSubscribe: () => void | null;
            onChangeHandler: () => void;
            shouldComponentUpdate(_nextProps: any, nextState: any): boolean;
            componentWillUnmount(): void;
            render(): JSX.Element;
            context: any;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<T, AlminReactContainerDiff<keyof T, keyof P>>>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<Pick<T, AlminReactContainerDiff<keyof T, keyof P>>> & Readonly<{
                children?: React.ReactNode;
            }>;
            refs: {
                [key: string]: React.ReactInstance;
            };
            componentDidMount?(): void;
            componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<Pick<T, AlminReactContainerDiff<keyof T, keyof P>>>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<Pick<T, AlminReactContainerDiff<keyof T, keyof P>>>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<Pick<T, AlminReactContainerDiff<keyof T, keyof P>>>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<Pick<T, AlminReactContainerDiff<keyof T, keyof P>>>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<Pick<T, AlminReactContainerDiff<keyof T, keyof P>>>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<Pick<T, AlminReactContainerDiff<keyof T, keyof P>>>, nextState: Readonly<{}>, nextContext: any): void;
        };
        displayName: string;
        contextType?: React.Context<any> | undefined;
    };
}
export default AlminReactContainer;
