"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlminReactContainer = void 0;
// MIT © 2017 azu
var React = require("react");
var assert = require("assert");
var almin_1 = require("almin");
var shallow_equal_object_1 = require("shallow-equal-object");
var AlminReactContainer = /** @class */ (function () {
    function AlminReactContainer() {
    }
    // T is Custom props
    // P is Almin state
    AlminReactContainer.create = function (WrappedComponent, context) {
        var _a;
        if (process.env.NODE_ENV !== "production") {
            assert.ok(typeof WrappedComponent === "function", "WrappedComponent should be React Component Class(Not instance)");
            assert.ok(context instanceof almin_1.Context, "`context` should be instance of Almin's Context");
        }
        var componentName = WrappedComponent.displayName || WrappedComponent.name;
        // AlminContainer's props is <T - P> type
        // T is State of Store, P is custom props of the `WrappedComponent`
        return _a = /** @class */ (function (_super) {
                __extends(AlminContainer, _super);
                function AlminContainer(props) {
                    var _this = _super.call(this, props) || this;
                    _this.onChangeHandler = function () {
                        _this.setState(context.getState());
                    };
                    _this.state = context.getState();
                    _this.unSubscribe = context.onChange(_this.onChangeHandler);
                    return _this;
                }
                AlminContainer.prototype.shouldComponentUpdate = function (_nextProps, nextState) {
                    // Almin StoreGroup use Object.assign merging by default
                    // It means that theses states are not strict equal always.
                    return !shallow_equal_object_1.shallowEqual(this.state, nextState);
                };
                AlminContainer.prototype.componentWillUnmount = function () {
                    if (typeof this.unSubscribe === "function") {
                        this.unSubscribe();
                    }
                };
                AlminContainer.prototype.render = function () {
                    // Workaround TS2.3.1: https://github.com/Microsoft/TypeScript/pull/13288
                    var C = WrappedComponent;
                    return React.createElement(C, __assign({}, this.state, this.props));
                };
                return AlminContainer;
            }(React.Component)),
            _a.displayName = "AlminContainer(" + componentName + ")",
            _a;
    };
    return AlminReactContainer;
}());
exports.AlminReactContainer = AlminReactContainer;
exports.default = AlminReactContainer;
//# sourceMappingURL=almin-react-container.js.map